#include <amxmod.inc>  // Include all functions from this inc
#include <xtrafun>  // Include all functions from this inc
#include <superheromod.inc>  // Include all functions from this inc

// VARIABLES
new gHeroName[]="Tutorial v2"
new bool:gHasTutorialPowers[SH_MAXSLOTS+1]//A Variable telling us if player has this hero
new gTutorialTimer[SH_MAXSLOTS+1]//A Variablefor a possible timer
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Tutorial v2","1.0","Freecode") // Register your hero. Name/version/Author
 
  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create Tutorial v2 Hero") //Send message to Server that hero is being created.. Debug purposes only
  register_cvar("tutorial_level", "10" )  //Resister the cvar that tells us what level he is avalible
  
  //Hero Name- Short Description- Long Description- false=Automatic Powers true=KeyDown powers- Hero level
  shCreateHero(gHeroName, "Tutorial v2", "Turn people into chicekns when they shoot you", false, "tutorial_level" )
  
  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("tutorial_init", "tutorial_init")
  shRegHeroInit(gHeroName, "tutorial_init")  // Initialize the hero
  //Make into a Tutorial
  register_event("ResetHUD","newRound","b") // Register event. ResetHUD/NewRound is for doing something once the newround starts.
  register_event("Damage", "tutorial_damage", "b", "2!0") // Register event. Damage is for doing something once you shoot someone or you get shot.
  register_srvcmd("tutorial_loop", "tutorial_loop")// Make a loop for something. Usualy a timer.
  set_task(1.0,"tutorial_loop",0,"",0,"b")

  // DEFAULT THE CVARS
  register_cvar("tutorial_cooldown", "45" )// Cvar. Cooldown the power that this hero has.
  register_cvar("tutorial_tuttime", "5") // Cvar. Set the # of seconds the timer will have.
}
//----------------------------------------------------------------------------------------------
public newRound(id, victim) // This is our NewRound event. 
{
  gPlayerUltimateUsed[id]=false // Tell the server on the newRound that the person with this power can use it again.
}
//----------------------------------------------------------------------------------------------
public tutorial_init() 
{
  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  new victim=str_to_num(temp)
  
  // 2nd Argument is 0 or 1 depending on whether the id has wolverine skills
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( !hasPowers ) // ! means not, or doesnt. In this case !hasPowers means Doesnt have this hero. So we will do something if a person doesnt have this hero.
  {
    tutorial_untutorial(victim) //Undo the last power from this hero before you droped it
    gTutorialTimer[id]=0 // Set the timer to 0
  }
    
  gHasTutorialPowers[id]=(hasPowers!=0) // Otherwise give him powers.

  new parm[1]
  parm[0]=id
  if ( hasPowers!=0 )// If the person has powers proceed to making the loop
  set_task( get_cvar_float("tutorial_tuttime"), "tutorial_loop", id, parm, 1, "b")
  else// otherwise romove task/loop
  remove_task(id)

}
//----------------------------------------------------------------------------------------------
public tutorial_damage(id) // Our Damage event
{
  new weapon, bodypart, attacker = get_user_attacker(id,weapon,bodypart) // Make any new variables that you will use in this damage event.

  if (!shModActive() || !gHasTutorialPowers[attacker] || gPlayerUltimateUsed[id] ) return PLUGIN_CONTINUE // Check if one of these things are active/inactive if yes then continue
  
  if ( is_user_alive(id) && id != attacker ) // Check to see if the user is alive and doing well :)
  {
    if ( !gHasTutorialPowers[attacker] ) return PLUGIN_HANDLED // See if he has the power or not. If not that stop right there.
    if ( gPlayerUltimateUsed[attacker] ) // If he used his ultimate and the cooldown time is still going then dont let him use the power again.
    {
	  playSoundDenySelect(attacker)
	  return PLUGIN_HANDLED 
	}
    // Start the ultimate timer and the heros ultimate power with the timer.
    gTutorialTimer[id]=get_cvar_num("tutorial_tuttime")+1
    tutorial_power(attacker,id)
    ultimateTimer(attacker, get_cvar_num("tutorial_cooldown") * 1.0)
  }
  return PLUGIN_CONTINUE
}
// Now this particular Damage event will do something when you shoot someone.
//----------------------------------------------------------------------------------------------
public tutorial_power(id,victim)//this is called ubove,when you shoot someone.
{
//Add all your cmds and functions to do to the person you shot(victim)
}
//----------------------------------------------------------------------------------------------
public tutorial_loop()
{
  new victim
  new params[1] 
  params[0] = victim 
  for ( new id=1; id<=SH_MAXSLOTS; id++ ) // Make a new id
  {
    if ( gHasTutorialPowers[id] && is_user_alive(id) ) // Check if alive and has tutorial powers
    {
      if ( gTutorialTimer[id]>0 )// Make sure the timer is still higher the 0
      {
        gTutorialTimer[id]--
        new message[128] //creat a message
        format(message, 127, "%d seconds left of tutorial mode", gTutorialTimer[id] ) // format/define the massage that we just created
        set_hudmessage(255,0,0,-1.0,0.3,0,1.0,1.0,0.0,0.0,4)// Set hud massage options like , special effects,how long it stays on, where on screen it shos up,etc...
        show_hudmessage( victim, message)// and show the message to the victim(the person that we attacked)
      }
      else
      {
        if ( gTutorialTimer[id] == 0 && is_user_alive(victim) ) // else if the timer is 0 undo the special power that we did to victim once we attacked him
        {
          gTutorialTimer[id]--
          tutorial_untutorial(victim)// Call the function to undo it
        }
      }
    }
  }
}
//----------------------------------------------------------------------------------------------
public tutorial_untutorial(victim) {
// undo everything that you did in tutorial_power(id,vicitm)
}
//----------------------------------------------------------------------------------------------
